Issue 14969 - [RFE] table control: allow TriState property for check box columns
Summary: [RFE] table control: allow TriState property for check box columns
Status: ACCEPTED
Alias: None
Product: Base
Classification: Application
Component: code (show other issues)
Version: OOo 1.0.3
Hardware: PC Windows XP
: P3 Trivial (vote)
Target Milestone: ---
Assignee: AOO issues mailing list
QA Contact:
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2003-05-27 15:31 UTC by kelvine
Modified: 2017-05-20 10:47 UTC (History)
1 user (show)

See Also:
Issue Type: ENHANCEMENT
Latest Confirmation in: ---
Developer Difficulty: ---


Attachments

Note You need to log in before you can comment on or make changes to this issue.
Description kelvine 2003-05-27 15:31:32 UTC
Hi,

MS Access boolean fields I believe can only have a true or false 
representation.  In fact I know of no way to set an MS Access boolean field to
not be a True or False representation.

This default use of a tristate field in the data source and the Table Control 
on a Form, leads to some confusion.

When changing MS Access boolean fields using the data source window or Table 
Control on a Form, the user can cycle through all three states implying a 
tristate situation. However the non true or false state is not saved and leads 
to user confusion.

Using ODBC to access MS Access XP tables.
Comment 1 christoph.lukasiak 2003-06-13 14:01:24 UTC
you are completely right that this behavior is confusing ...

but: we can only ask the driver if it supports tristate bools and if 
it say yes, we belive him ... in this special case it lies (means: 
the programmer of the driver doesn't apply to the standard)

so this is a driver problem we cannot fix in the office :(

p.s. i guess you use an ODBC - with an ADO driver you should get an 
error message
Comment 2 kelvine 2003-06-16 04:33:59 UTC
Hi,

Thanks for looking into this.

I just thought I would let you know it is a more generic issue than 
just the MS Access driver.  

The internal dBase driver exhibits the same behaviour. Should I 
provide a dBase file or MS Access file to a user with all boolean 
files initialised (that is effectively true/false, Yes/No) I would 
not want the user to be able to set the boolean field back to an 
unknown state.

I was looking for a more generic answer where I as the user can 
determine the tristate/bistate attribute in the data source and  
Table Control.

However a wontfix answer is good. That means I can largely forget 
about OO forms as a valid data entry facility.  At least I can now 
move on.

I really do appreciate the answer.

Thanks

Kelvin
Comment 3 christoph.lukasiak 2003-06-16 11:35:46 UTC
hi kelvin,

sorry that i frustrated you - maybe i understood you wrong

1. dBase support tristate, either do we
2. in the control property browser of a checkbox (boolfield) you can 
set the property 'tristate' to no - then the user can only use true 
or false in his form

p.s. i hope that will help you further - else don't hestitate to ask 
again
Comment 4 kelvine 2003-06-16 11:50:55 UTC
Hi,

You actually didn't frustrate me at all.  

I am however a little disappointed in the product and I have to 
accept its limitations.

In a Form using the tristate/bistate setting only provides the user 
with the ability to set this setting for single record data entry.  
That is the Form displays a single record. The boolean field is a 
control and the control has the tristate setting set to No.

If I use the Table control in a form or the data source window for 
data entry there is no way to set the tristate/bistate setting for a 
boolen field.  It is always tristate for dBase and MS Access files.

As a developer that is not acceptable to me.  In twenty years I have 
never provided the ability for a user to set a boolean field to an 
undetermined state. That means for the moment I have to stick with 
MS Access as my front end for my applications.

By marking this as wontfix it means that I have a resolution.  That 
is it will never work to my satisfaction.

I don't think this is in the interests of OpenOffice.org, but I do 
have my answer and I do appreciate having an answer.

Thanks again

Kelvin
Comment 5 christoph.lukasiak 2003-06-16 12:45:48 UTC
hi,

by rethinking this problem we came to the conclusion, that it is a 
bug if you can't disable the tristate in table controls (therefore 
now exist an internal bug, that will be fixed hopefully) - i know 
that this is only a part of your problem, but the rest is as you 
mentioned unfortunately a conceptual problem

p.s. thank you for your ambitious behavior
Comment 6 kelvine 2003-06-16 14:27:42 UTC
Hi,

Thanks for rechecking this issue.  I am happy that I no longer have 
my answer.

If this can be done for the Table Control in a Form, can it also be 
done for the Data Source window (F4).  That is right click on the 
column heading and set Tristate to No.

By doing this OpenOffice.org covers the three areas that I have seen 
where Tristate/Bistate needs to be potentially set.

Also for completeness, I raised the dBase issue separately in issue 
14970 as MS Access and dBase were two different data formats.  If 
the problem was to be handled at the data level then they were 
separate issues. If they are handled at the user interface level 
they can be treated as the one issue.

I am also wondering why it was made an internal issue.  From a 
marketing point of view keeping it as an Issuezilla issue which gets 
resolved gives you more visible credit of responding to user 
suggestions.  I always told my staff 80% of the job is doing the 
job, 20% is making sure other people know you are doing the job.

If/when this issue gets fixed it reinforces that you are responsive 
to users needs and that is something in my opinion that is important 
to keep public.

Just my thoughts.

Thanks again for revisiting this issue. I really did not expect an 
outcome.

Kelvin

Comment 7 christoph.lukasiak 2003-06-16 16:06:31 UTC
>If this can be done for the Table Control in a Form, can it also be 
>done for the Data Source window (F4).  That is right click on the 
>column heading and set Tristate to No.

Yes, but the first case is a bug, the second a feature wish - so you 
can write you idea and hopefully it will be integrated
Comment 8 Frank Schönheit 2003-07-01 13:23:33 UTC
reopening (sorry Chris :)

For 2.0, we plan to offer a more "database type"-centric view, instead
of the current architecture-centric view to databases. This means a
user would tell us that he connects to "MS Access", and we do all the
technical stuff (chose ADO, set the weird URL, and such).

In such a scenario, it is conceivable that the underlying driver
supports a feature to "correct" the wrong information returned by the
driver (about the nullability of a boolean column), thus making the UI
working "more correct".

However, I intentionally say "conceivable". This needs further
evaluation, and consideration of efforts and benefits, but maybe a
solutuion for this becomes easier with 2.0.

Kelvin, I fear that effectively, this is not different from WONTFIX
for the moment. But I simply do not want to lose this bug from the
radar, if there's the possibility that we can easily do something
about it (the tristate handling was never really satisfying).
Comment 9 Frank Schönheit 2003-07-01 14:23:31 UTC
clarification (as Chris told me that it was confusing :):

I misinterpreted the bug - I overlooked Chris' statement about the
internal bug. So I wanted to see this here as exactly the bug which
was alreaedy submitted.
Well, I leave this one here open, anyway, because I agree the public
is better than non-public in nearly all circumstances, and because
here we have the history of the issue (which we do not have in this
new internal bug).
Comment 10 Frank Schönheit 2003-10-13 09:20:36 UTC
accepting
Comment 11 hans_werner67 2004-02-02 12:38:18 UTC
change subcomponent to 'none'
Comment 12 Frank Schönheit 2004-02-04 15:58:54 UTC
changing summary from 
  MS Access boolean field can only be bistate. Check box show tristate
to
  [RFE] table control: allow TriState property for check box columns

I hope that this now really is what we concluded in the lengthy discussions
above ... :)
Comment 13 kelvine 2004-02-05 00:21:01 UTC
Hi,

As this issue now only pertains to the Table Control, I have opened a separate 
issue 25091 for the Data Source.

Thanks

Kelvin

Comment 14 marc.neumann 2004-04-23 09:43:13 UTC
MSC: according to
http://development.openoffice.org/releases/Target_Milestone.html retarget to
OOo_Later
Comment 15 Marcus 2017-05-20 10:47:49 UTC
Reset assigne to the default "issues@openoffice.apache.org".